diff --git a/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java b/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
index 458320918..5f9b17c1e 100644
--- a/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
+++ b/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
@@ -724,20 +724,20 @@ public class ServerPacketHandler extends PacketHandler
                 }
                 if (!isLineValid)
                 {
-                    packet.signLines[i] = "!?";
+                    signUpdatePacket.signLines[i] = "!?";
                 }
             }
 
             if (blockEntity instanceof SignBlockEntity)
             {
-                int x = packet.xPosition;
-                int y = packet.yPosition;
-                int z = packet.zPosition;
+                int x = signUpdatePacket.xPosition;
+                int y = signUpdatePacket.yPosition;
+                int z = signUpdatePacket.zPosition;
                 SignBlockEntity tileEntity = (SignBlockEntity) blockEntity;
-                System.arraycopy(packet.signLines, 0, tileEntity.signText, 0, 4);
+                System.arraycopy(signUpdatePacket.signLines, 0, tileEntity.signText, 0, 4);
 
-                tileEntity.setColor(TextFormatting.FORMATTINGS[packet.color]);
-                tileEntity.setPicture(EnumSignPicture.values()[packet.picture]);
+                tileEntity.setColor(TextFormatting.FORMATTINGS[signUpdatePacket.color]);
+                tileEntity.setPicture(EnumSignPicture.values()[signUpdatePacket.picture]);
 
                 tileEntity.setChanged();
                 worldserver.markBlockNeedsUpdate(x, y, z);
@@ -773,28 +773,28 @@ public class ServerPacketHandler extends PacketHandler
     }
 
     @Override
-    public void handleSetPaintingMotive(SetPaintingArtPacket packet)
+    public void handleSetPaintingMotive(SetPaintingArtPacket setPaintingArtPacket)
     {
-        playerEntity.setSelectedArt(ArtType.values.get(packet.motive));
+        playerEntity.setSelectedArt(ArtType.values.get(setPaintingArtPacket.motive));
     }
     
     @Override
-    public void handleCustomPayload(CustomPayloadPacket packet) {
-    	if("BTA|RotationLock".equals(packet.channel)) {
-    		if(packet.data.length == 4) {
-        		playerEntity.rotationLock = Direction.getDirectionById(packet.data[0]);
-        		playerEntity.rotationLockHorizontal = Direction.getDirectionById(packet.data[1]);
-        		playerEntity.rotationLockVertical = Direction.getDirectionById(packet.data[2]);
-        		playerEntity.placementModeOverride = PlacementMode.get(packet.data[3]);
+    public void handleCustomPayload(CustomPayloadPacket customPayloadPacket) {
+    	if("BTA|RotationLock".equals(customPayloadPacket.channel)) {
+    		if(customPayloadPacket.data.length == 4) {
+        		playerEntity.rotationLock = Direction.getDirectionById(customPayloadPacket.data[0]);
+        		playerEntity.rotationLockHorizontal = Direction.getDirectionById(customPayloadPacket.data[1]);
+        		playerEntity.rotationLockVertical = Direction.getDirectionById(customPayloadPacket.data[2]);
+        		playerEntity.placementModeOverride = PlacementMode.get(customPayloadPacket.data[3]);
     		}
-    	}else if("BTA|Flag".equals(packet.channel)) {
-    		if(packet.data.length == 24 * 16 && playerEntity.craftingInventory instanceof FlagMenu) {
+    	}else if("BTA|Flag".equals(customPayloadPacket.channel)) {
+    		if(customPayloadPacket.data.length == 24 * 16 && playerEntity.craftingInventory instanceof FlagMenu) {
     			FlagMenu flagMenu = (FlagMenu) playerEntity.craftingInventory;
     			FlagBlockEntity flag = flagMenu.flag;
 
     			if(flag.owner == null || flag.owner.equals(playerEntity.uuid)) {
                     flag.owner = playerEntity.uuid;
-        			System.arraycopy(packet.data, 0, flag.flagColors, 0, 24 * 16);
+        			System.arraycopy(customPayloadPacket.data, 0, flag.flagColors, 0, 24 * 16);
 
         			playerEntity.world.markBlockNeedsUpdate(flag.x, flag.y, flag.z);
     			}else {
@@ -804,9 +804,9 @@ public class ServerPacketHandler extends PacketHandler
     				playerEntity.world.markBlockNeedsUpdate(flag.x, flag.y, flag.z);
     			}
     		}
-    	} else if ("BTA|WandMonster".equals(packet.channel)) {
+    	} else if ("BTA|WandMonster".equals(customPayloadPacket.channel)) {
             if (playerEntity.getHeldItem() != null && playerEntity.getHeldItem().getItem() == Items.WAND_MONSTER_SPAWNER){
-                String id = new String(packet.data, StandardCharsets.UTF_8);
+                String id = new String(customPayloadPacket.data, StandardCharsets.UTF_8);
                 playerEntity.getHeldItem().getData().putString("monster", id);
             }
         }
@@ -814,13 +814,11 @@ public class ServerPacketHandler extends PacketHandler
 
     @Override
     public void handleRequestCommandManagerPacket(RequestCommandManagerPacket packet) {
-        ServerPlayer player = this.mcServer.playerList.getPlayerEntity(packet.username);
-        if (player == null) return;
-        player.playerNetServerHandler.sendPacket(
+        sendPacket(
             new CommandManagerPacket(
-                this.mcServer.getDimensionWorld(player.dimension)
+                this.mcServer.getDimensionWorld(playerEntity.dimension)
                     .getCommandManager().getDispatcher(),
-                new ServerCommandSource(this.mcServer, player),
+                new ServerCommandSource(this.mcServer, playerEntity),
                 packet.text,
                 packet.cursor
             )
@@ -842,7 +840,6 @@ public class ServerPacketHandler extends PacketHandler
     private int field_15_f;
     private int field_22004_g;
     private int playerInAirTime;
-    private boolean field_22003_h;
     private double lastPosX;
     private double lastPosY;
     private double lastPosZ;
diff --git a/src/main/java/net/minecraft/server/player/PlayerListBox.java b/src/main/java/net/minecraft/server/player/PlayerListBox.java
index 7253843ee..1b6dbbd76 100644
--- a/src/main/java/net/minecraft/server/player/PlayerListBox.java
+++ b/src/main/java/net/minecraft/server/player/PlayerListBox.java
@@ -3,22 +3,20 @@ package net.minecraft.server.player;
 import java.util.Vector;
 import javax.swing.JList;
 
-import net.minecraft.server.entity.player.ServerPlayer;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.core.net.IUpdatePlayerListBox;
 
-// Referenced classes of package net.minecraft.src:
-//            IUpdatePlayerListBox, ServerConfigurationManager, ServerPlayer
-
-public class PlayerListBox extends JList
+public class PlayerListBox extends JList<String>
     implements IUpdatePlayerListBox
 {
+    private final MinecraftServer mcServer;
+    private int updateCounter;
 
     public PlayerListBox(MinecraftServer minecraftserver)
     {
         updateCounter = 0;
         mcServer = minecraftserver;
-        minecraftserver.func_6022_a(this);
+        minecraftserver.addPlayerListBox(this);
     }
 
     @Override
@@ -26,16 +24,13 @@ public class PlayerListBox extends JList
     {
         if(updateCounter++ % 20 == 0)
         {
-            Vector vector = new Vector();
+            Vector<String> vector = new Vector<>();
             for(int i = 0; i < mcServer.playerList.playerEntities.size(); i++)
             {
-                vector.add(((ServerPlayer)mcServer.playerList.playerEntities.get(i)).username);
+                vector.add(mcServer.playerList.playerEntities.get(i).username);
             }
 
             setListData(vector);
         }
     }
-
-    private MinecraftServer mcServer;
-    private int updateCounter;
 }
diff --git a/src/main/java/net/minecraft/server/player/PlayerManager.java b/src/main/java/net/minecraft/server/player/PlayerManager.java
index f9f855ec3..e69a24bef 100644
--- a/src/main/java/net/minecraft/server/player/PlayerManager.java
+++ b/src/main/java/net/minecraft/server/player/PlayerManager.java
@@ -82,8 +82,8 @@ public class PlayerManager
     {
         int xChunk = (int)player.x >> 4;
         int zChunk = (int)player.z >> 4;
-        player.field_9155_d = player.x;
-        player.field_9154_e = player.z;
+        player.viewingX = player.x;
+        player.viewingZ = player.z;
         int k = 0;
         int radius = viewRadius;
         int dx = 0;
@@ -116,8 +116,8 @@ public class PlayerManager
 
     public void removePlayer(ServerPlayer entityplayermp)
     {
-        int i = (int)entityplayermp.field_9155_d >> 4;
-        int j = (int)entityplayermp.field_9154_e >> 4;
+        int i = (int)entityplayermp.viewingX >> 4;
+        int j = (int)entityplayermp.viewingZ >> 4;
         for(int k = i - viewRadius; k <= i + viewRadius; k++)
         {
             for(int l = j - viewRadius; l <= j + viewRadius; l++)
@@ -134,59 +134,55 @@ public class PlayerManager
         players.remove(entityplayermp);
     }
 
-    private boolean func_544_a(int i, int j, int k, int l)
+    private boolean chunkWithinViewRadius(int chunkX, int chunkZ, int originX, int originZ)
     {
-        int i1 = i - k;
-        int j1 = j - l;
-        if(i1 < -viewRadius || i1 > viewRadius)
-        {
-            return false;
-        }
-        return j1 >= -viewRadius && j1 <= viewRadius;
+        int cDX = chunkX - originX;
+        int cDZ = chunkZ - originZ;
+        return cDZ >= -viewRadius && cDZ <= viewRadius && cDX >= -viewRadius && cDX <= viewRadius;
     }
 
-    public void func_543_c(ServerPlayer entityplayermp)
+    public void onPlayerMoved(ServerPlayer player)
     {
-        int i = (int)entityplayermp.x >> 4;
-        int j = (int)entityplayermp.z >> 4;
-        double d = entityplayermp.field_9155_d - entityplayermp.x;
-        double d1 = entityplayermp.field_9154_e - entityplayermp.z;
-        double d2 = d * d + d1 * d1;
-        if(d2 < 64D)
+        int chunkX = (int)player.x >> 4;
+        int chunkZ = (int)player.z >> 4;
+        double dx = player.viewingX - player.x;
+        double dz = player.viewingZ - player.z;
+        double dSqr = dx * dx + dz * dz;
+        if(dSqr < 64D) // Do nothing If moved less then 8 blocks horizontally
         {
             return;
         }
-        int k = (int)entityplayermp.field_9155_d >> 4;
-        int l = (int)entityplayermp.field_9154_e >> 4;
-        int i1 = i - k;
-        int j1 = j - l;
-        if(i1 == 0 && j1 == 0)
+        int playerChunkX = (int)player.viewingX >> 4;
+        int playerChunkZ = (int)player.viewingZ >> 4;
+        int cDX = chunkX - playerChunkX;
+        int cDZ = chunkZ - playerChunkZ;
+        if(cDX == 0 && cDZ == 0) // If still on same chunk
         {
             return;
         }
-        for(int k1 = i - viewRadius; k1 <= i + viewRadius; k1++)
+        for(int _cx = chunkX - viewRadius; _cx <= chunkX + viewRadius; _cx++)
         {
-            for(int l1 = j - viewRadius; l1 <= j + viewRadius; l1++)
+            for(int _cz = chunkZ - viewRadius; _cz <= chunkZ + viewRadius; _cz++)
             {
-                if(!func_544_a(k1, l1, k, l))
+                if(!chunkWithinViewRadius(_cx, _cz, playerChunkX, playerChunkZ)) // If chunk was not in previous render radius add the chunk to the player
                 {
-                    getPlayerInstance(k1, l1, true).addPlayer(entityplayermp);
+                    getPlayerInstance(_cx, _cz, true).addPlayer(player);
                 }
-                if(func_544_a(k1 - i1, l1 - j1, i, j))
+                if(chunkWithinViewRadius(_cx - cDX, _cz - cDZ, chunkX, chunkZ))
                 {
                     continue;
                 }
-                PlayerInstance playerinstance = getPlayerInstance(k1 - i1, l1 - j1, false);
+                PlayerInstance playerinstance = getPlayerInstance(_cx - cDX, _cz - cDZ, false);
                 if(playerinstance != null)
                 {
-                    playerinstance.removePlayer(entityplayermp);
+                    playerinstance.removePlayer(player);
                 }
             }
 
         }
 
-        entityplayermp.field_9155_d = entityplayermp.x;
-        entityplayermp.field_9154_e = entityplayermp.z;
+        player.viewingX = player.x;
+        player.viewingZ = player.z;
     }
 
     public int getMaxTrackingDistance()
@@ -209,7 +205,7 @@ public class PlayerManager
         private int maxZ;
 
         public PlayerInstance(int chunkX, int chunkZ) {
-            players = new ArrayList();
+            players = new ArrayList<>();
             blocksToUpdate = new int[10];
             numBlocksToUpdate = 0;
             this.chunkX = chunkX;
@@ -240,7 +236,7 @@ public class PlayerManager
                 if (numBlocksToUpdate > 0) {
                     playerInstancesToUpdate.remove(this);
                 }
-                server.getDimensionWorld(dimension).chunkProviderServer.func_35391_d(chunkX, chunkZ);
+                server.getDimensionWorld(dimension).chunkProviderServer.dropChunk(chunkX, chunkZ);
             }
             player.loadedChunks.remove(currentChunk);
             if (player.field_420_ah.contains(currentChunk)) {
diff --git a/src/main/java/net/minecraft/server/world/ServerPlayerController.java b/src/main/java/net/minecraft/server/world/ServerPlayerController.java
index 9a92019e7..63b7cc607 100644
--- a/src/main/java/net/minecraft/server/world/ServerPlayerController.java
+++ b/src/main/java/net/minecraft/server/world/ServerPlayerController.java
@@ -14,6 +14,7 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.BlockUpdatePacket;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.server.entity.player.ServerPlayer;
 
@@ -121,7 +122,7 @@ public class ServerPlayerController
     	}
         Block block = Block.getBlock(id);
         BlockEntity blockEntity = thisWorld.getBlockEntity(x, y, z);
-        thisWorld.playBlockEvent(player, 2001, x, y, z, id);
+        thisWorld.playBlockEvent(player, LevelListener.EVENT_BLOCK_BREAK, x, y, z, id);
         boolean flag = removeBlock(x, y, z);
         if(flag) {
         	if(block != null) {
diff --git a/src/main/java/net/minecraft/server/world/WorldManager.java b/src/main/java/net/minecraft/server/world/WorldManager.java
index cb300ce19..5cf17d11a 100644
--- a/src/main/java/net/minecraft/server/world/WorldManager.java
+++ b/src/main/java/net/minecraft/server/world/WorldManager.java
@@ -113,7 +113,7 @@ public class WorldManager
     @Override
 	public void tileEntityChanged(int x, int y, int z, BlockEntity blockEntity)
     {
-        mcServer.playerList.sendTileEntityToPlayer(x, y, z, blockEntity);
+        mcServer.playerList.sendBlockEntityToPlayer(x, y, z, blockEntity);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/server/world/WorldServer.java b/src/main/java/net/minecraft/server/world/WorldServer.java
index 05158ca3d..92a7d413b 100644
--- a/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -19,20 +19,12 @@ import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.server.MinecraftServer;
 
-// Referenced classes of package net.minecraft.src:
-//            World, WorldProvider, MCHash, Animal,
-//            EntityWaterMob, Entity, Player, ISaveHandler,
-//            ChunkProviderServer, BlockEntity, WorldInfo, MathHelper,
-//            ServerConfigurationManager, WeatherEffectPacket, EnitityEventPacket, EntityTracker,
-//            Explosion, ExplosionPacket, BlockEventPacket, BedMessagePacket,
-//            IChunkProvider
-
 public class WorldServer extends World
 {
 
-    public WorldServer(MinecraftServer minecraftserver, LevelStorage isavehandler, String name, int dimensionId, WorldType worldType, long seed, SpawnerMobs.SpawnerConfig spawnerConfig)
+    public WorldServer(MinecraftServer minecraftserver, LevelStorage isavehandler, String name, int dimensionId, WorldType worldType, long seed)
     {
-        super(isavehandler, name, seed, Dimension.getDimensionList().get(dimensionId), worldType, spawnerConfig);
+        super(isavehandler, name, seed, Dimension.getDimensionList().get(dimensionId), worldType);
         entityIntHashMap = new IntHashMap<>();
         mcServer = minecraftserver;
     }
@@ -46,11 +38,6 @@ public class WorldServer extends World
         }
     }
 
-    public void func_12017_b(Entity entity, boolean flag)
-    {
-        super.updateEntityWithOptionalForce(entity, flag);
-    }
-
     @Override
     protected IChunkProvider createChunkProvider()
     {
@@ -75,10 +62,11 @@ public class WorldServer extends World
     }
 
     @Override
-    public boolean canMineBlock(Player entityplayer, int i, int j, int k)
+    public boolean canMineBlock(Player entityplayer, int x, int y, int z)
     {
-        int l = (int)MathHelper.abs(i - levelData.getSpawnX());
-        int i1 = (int)MathHelper.abs(k - levelData.getSpawnZ());
+        // TODO make spawn protection a named constant *and* server configurable
+        int l = (int)MathHelper.abs(x - levelData.getSpawnX());
+        int i1 = (int)MathHelper.abs(z - levelData.getSpawnZ());
         if(l > i1)
         {
             i1 = l;
@@ -107,7 +95,7 @@ public class WorldServer extends World
         if(areEnoughPlayersFullyAsleep())
         {
             boolean wasInterrupted = false;
-            if(spawningConfig.canHostileSpawn(this) && getPlayersRequiredToSkipNight() <= 1)
+            if(getSpawnerConfig().canHostileSpawn(this) && getPlayersRequiredToSkipNight() <= 1)
             {
                 wasInterrupted = SpawnerMobs.performSleepSpawning(this, players);
             }
diff --git a/src/main/java/net/minecraft/server/world/WorldServerMulti.java b/src/main/java/net/minecraft/server/world/WorldServerMulti.java
index a0b3d1e7b..2984ad475 100644
--- a/src/main/java/net/minecraft/server/world/WorldServerMulti.java
+++ b/src/main/java/net/minecraft/server/world/WorldServerMulti.java
@@ -1,6 +1,5 @@
 package net.minecraft.server.world;
 
-import net.minecraft.core.world.SpawnerMobs;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.core.world.save.LevelStorage;
@@ -11,9 +10,9 @@ import net.minecraft.core.world.save.LevelStorage;
 public class WorldServerMulti extends WorldServer
 {
 
-    public WorldServerMulti(MinecraftServer minecraftserver, LevelStorage isavehandler, String name, int dimensionId, WorldType worldType, long seed, WorldServer worldserver, SpawnerMobs.SpawnerConfig spawnerConfig)
+    public WorldServerMulti(MinecraftServer minecraftserver, LevelStorage isavehandler, String name, int dimensionId, WorldType worldType, long seed, WorldServer worldserver)
     {
-        super(minecraftserver, isavehandler, name, dimensionId, worldType, seed, spawnerConfig);
+        super(minecraftserver, isavehandler, name, dimensionId, worldType, seed);
         savedDataStorage = worldserver.savedDataStorage;
     }
 }
diff --git a/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java b/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
index 7abb9ff4f..e5ba04ba6 100644
--- a/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
+++ b/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
@@ -42,13 +42,13 @@ public class ChunkProviderServer
         return chunkMap.containsKey(ChunkCoordinate.toInt(chunkX, chunkZ));
     }
 
-    public void func_35391_d(int chunkX, int chunkZ)
+    public void dropChunk(int chunkX, int chunkZ)
     {
         ChunkCoordinates spawnCoords = world.getSpawnPoint();
         int spawnDistanceX = (chunkX * 16 + 8) - spawnCoords.x;
         int spawnDistanceZ = (chunkZ * 16 + 8) - spawnCoords.z;
-        int r = 128;
-        if(spawnDistanceX < -r || spawnDistanceX > r || spawnDistanceZ < -r || spawnDistanceZ > r)
+        int r = 128; // TODO replace spawn chunk values with a named constant
+        if(spawnDistanceX < -r || spawnDistanceX > r || spawnDistanceZ < -r || spawnDistanceZ > r) // Drop chunk if outside of spawn radius
         {
             droppedChunksSet.add(ChunkCoordinate.toInt(chunkX, chunkZ));
         }
diff --git a/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/button/button.png.mcmeta b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/button/button.png.mcmeta
new file mode 100644
index 000000000..6f27a3b2b
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/button/button.png.mcmeta
@@ -0,0 +1,15 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 200,
+            "height": 20,
+            "border": {
+                "top": 2,
+                "left": 2,
+                "right": 2,
+                "bottom": 3
+            }
+        }
+    }
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/button/button_disabled.png.mcmeta b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/button/button_disabled.png.mcmeta
new file mode 100644
index 000000000..b321e532b
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/button/button_disabled.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 200,
+            "height": 20,
+            "border": 1
+        }
+    }
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/button/button_highlighted.png.mcmeta b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/button/button_highlighted.png.mcmeta
new file mode 100644
index 000000000..6f27a3b2b
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/button/button_highlighted.png.mcmeta
@@ -0,0 +1,15 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 200,
+            "height": 20,
+            "border": {
+                "top": 2,
+                "left": 2,
+                "right": 2,
+                "bottom": 3
+            }
+        }
+    }
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/slider/slider.png.mcmeta b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/slider/slider.png.mcmeta
new file mode 100644
index 000000000..54789e1bc
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/slider/slider.png.mcmeta
@@ -0,0 +1,15 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 8,
+            "height": 20,
+            "border": {
+                "top": 2,
+                "left": 2,
+                "right": 2,
+                "bottom": 3
+            }
+        }
+    }
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/slider/slider_background.png.mcmeta b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/slider/slider_background.png.mcmeta
new file mode 100644
index 000000000..b321e532b
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/slider/slider_background.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 200,
+            "height": 20,
+            "border": 1
+        }
+    }
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/slider/slider_disabled.png.mcmeta b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/slider/slider_disabled.png.mcmeta
new file mode 100644
index 000000000..9687b34ef
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/slider/slider_disabled.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 8,
+            "height": 20,
+            "border": 1
+        }
+    }
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/slider/slider_highlighted.png.mcmeta b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/slider/slider_highlighted.png.mcmeta
new file mode 100644
index 000000000..54789e1bc
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/slider/slider_highlighted.png.mcmeta
@@ -0,0 +1,15 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 8,
+            "height": 20,
+            "border": {
+                "top": 2,
+                "left": 2,
+                "right": 2,
+                "bottom": 3
+            }
+        }
+    }
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/switch/switch.png.mcmeta b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/switch/switch.png.mcmeta
new file mode 100644
index 000000000..6f27a3b2b
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/switch/switch.png.mcmeta
@@ -0,0 +1,15 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 200,
+            "height": 20,
+            "border": {
+                "top": 2,
+                "left": 2,
+                "right": 2,
+                "bottom": 3
+            }
+        }
+    }
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/switch/switch_background.png.mcmeta b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/switch/switch_background.png.mcmeta
new file mode 100644
index 000000000..b321e532b
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/switch/switch_background.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 200,
+            "height": 20,
+            "border": 1
+        }
+    }
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/switch/switch_disabled.png.mcmeta b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/switch/switch_disabled.png.mcmeta
new file mode 100644
index 000000000..b321e532b
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/switch/switch_disabled.png.mcmeta
@@ -0,0 +1,10 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 200,
+            "height": 20,
+            "border": 1
+        }
+    }
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/switch/switch_highlighted.png.mcmeta b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/switch/switch_highlighted.png.mcmeta
new file mode 100644
index 000000000..6f27a3b2b
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/switch/switch_highlighted.png.mcmeta
@@ -0,0 +1,15 @@
+{
+    "gui": {
+        "scaling": {
+            "type": "nine_slice",
+            "width": 200,
+            "height": 20,
+            "border": {
+                "top": 2,
+                "left": 2,
+                "right": 2,
+                "bottom": 3
+            }
+        }
+    }
+}
\ No newline at end of file
